--=============== МОДУЛЬ 2. РАБОТА С БАЗАМИ ДАННЫХ =======================================
--= ПОМНИТЕ, ЧТО НЕОБХОДИМО УСТАНОВИТЬ ВЕРНОЕ СОЕДИНЕНИЕ И ВЫБРАТЬ СХЕМУ PUBLIC===========
SET search_path TO public;

--======== ОСНОВНАЯ ЧАСТЬ ==============

--ЗАДАНИЕ №1
--Выведите уникальные названия регионов из таблицы адресов
select distinct district from address


--ЗАДАНИЕ №2
--Доработайте запрос из предыдущего задания, чтобы запрос выводил только те регионы,
--названия которых начинаются на "K" и заканчиваются на "a", и названия не содержат пробелов
select distinct district from address
 where district like'K%a'
   and district not like '% %'

--ЗАДАНИЕ №3
--Получите из таблицы платежей за прокат фильмов информацию по платежам, которые выполнялись
--в промежуток с 17 марта 2007 года по 19 марта 2007 года включительно,
--и стоимость которых превышает 1.00.
--Платежи нужно отсортировать по дате платежа.
select * from payment p
 where payment_date::date between '17-MAR-2007'::date and '19-MAR-2007'::date + interval '1 day'
   and amount > 1
 order by amount;


--********ИСПРАВЛЕНИЕ********--
/*
В 3 задании в результат попали лишние данные за 20 число, внимательней к типам данных с которыми работаете.
Так как payment_date привели к типу данных date, то в при сравнении в between границы диапазона будут включены и 19 число попадает в результат,
но дополнительно Вы 19 число увеличили через interval на один день и таким образом все данные за 20 число попадают в результат.
*/

select * from payment p
 where payment_date::date between '17-MAR-2007'::date and '19-MAR-2007'::date
   and amount > 1
 order by amount;
-- да, интервал был лишний, спасибо! Возникает вопрос оптимизации подобного запроса: допустим, payment_date проиндексирован, будет ли работать индекс в таком запросе при конвертации столбца в date?


--ЗАДАНИЕ №4
-- Выведите информацию о 10-ти последних платежах за прокат фильмов.
select * from payment p
 order by payment_date desc
 limit 10;


--ЗАДАНИЕ №5
--Выведите следующую информацию по покупателям:
--  1. Фамилия и имя (в одной колонке через пробел)
--  2. Электронная почта
--  3. Длину значения поля email
--  4. Дату последнего обновления записи о покупателе (без времени)
--Каждой колонке задайте наименование на русском языке.
select concat(first_name, ' ', last_name) "Фамилия и имя", email "Электронная почта", length(email) "Длина почты", last_update::date "Дата последнего обновления записи"
  from customer;


--ЗАДАНИЕ №6
--Выведите одним запросом активных покупателей, имена которых Kelly или Willie.
--Все буквы в фамилии и имени из нижнего регистра должны быть переведены в высокий регистр.
select upper(first_name), upper(last_name)
  from customer c
 where upper(first_name) in ('KELLY', 'WILLIE');

--********ИСПРАВЛЕНИЕ********--
--В 6 задании нужно добавить условие, которое отфильтрует не активных покупателей.
select upper(first_name), upper(last_name)
  from customer c
 where upper(first_name) in ('KELLY', 'WILLIE')
   and active  = 1;


--======== ДОПОЛНИТЕЛЬНАЯ ЧАСТЬ ==============

--ЗАДАНИЕ №1
--Выведите одним запросом информацию о фильмах, у которых рейтинг "R"
--и стоимость аренды указана от 0.00 до 3.00 включительно,
--а также фильмы c рейтингом "PG-13" и стоимостью аренды больше или равной 4.00.
select * from film f
 where rating = 'R'
   and rental_rate between 0 and 3
    or (rating = 'PG-13' and rental_rate >= 4)



with mt as
(select 3 c
union all
select 3.0001
union all
select 3.00
union all
select 2.99999)

select * from mt where c between 0 and 3



--ЗАДАНИЕ №2
--Получите информацию о трёх фильмах с самым длинным описанием фильма.
select * from
 (
   select distinct on (film_id) f.* from film f -- потому что film_id не уникальное значение и #116 всплывает дважды
 )  t
 order by character_length(description) desc
limit 3

--********ИСПРАВЛЕНИЕ********--
/*
film_id - это первичный ключ таблицы film и соответственно имеет ограничение unique, что означает, что значения в этом столбце строго уникальны. Если каким-то образом у Вас в результат три раза попадает значение идентификатора 116, значит Вы либо что-то сильно перемудрили в запросе, либо внесли перемудрили в запросе, а за одно внесли изменения в структуру базы и, к примеру, удалили ограничение первичного ключа.
*/

--Я работал с public схемой общей БД, а там картина весёлая:
select film_id, count(*)
  from film
 group by film_id
having count(*) > 1
order by 2 desc;
/*
652	14
273	14
51	14
951	14
839	14
70	14
350	14
758	14
539	14
874	14
278	14
946	14
...
и первчиный ключ отсутствует в film
*/
--в локальном dvd-rental, конечно, всё ок
select * from film
 order by character_length(description) desc
limit 3



--ЗАДАНИЕ №3
-- Выведите Email каждого покупателя, разделив значение Email на 2 отдельных колонки:
--в первой колонке должно быть значение, указанное до @,
--во второй колонке должно быть значение, указанное после @.
select email, split_part(email, '@', 1) логин, split_part(email, '@', 2) домен from customer c


--ЗАДАНИЕ №4
--Доработайте запрос из предыдущего задания, скорректируйте значения в новых колонках:
--первая буква должна быть заглавной, остальные строчными.
select email, initcap(split_part(email, '@', 1)) логин, initcap(split_part(email, '@', 2)) домен from customer c

--********ИСПРАВЛЕНИЕ********--
/*
 В 4 дополнительном функция initcap к верхнему регистру приведет первую букву каждого слова в строке, а нужно работать только с самой первой буквой строки, как вариант можно написать вот такой запрос:
select customer_id, email,
	   concat(upper(left(split_part(email, '@', 1), 1)), substring(split_part(email, '@', 1), 2)),
	   concat(upper(left(split_part(email, '@', 2), 1)), substring(split_part(email, '@', 2), 2))
from customer
*/

-- да, упустил, спасибо. Тогда ещё лучше с lower(), на случай, если где-то дальше в теле будет верхний регистр
select customer_id, email,
	   concat(upper(left(split_part(email, '@', 1), 1)), lower(substring(split_part(email, '@', 1), 2))) логин,
	   concat(upper(left(split_part(email, '@', 2), 1)), lower(substring(split_part(email, '@', 2), 2))) домен
from customer;
